
public class DataSealer {
    // This class is used to "seal" or "unseal" a sequence of values.   "Sealing" protects the
    //     confidentiality of a value, so that the only way to recover the initial value is to
    //     "unseal" the value using the same key that was used to seal it.   At the same time,
    //     "sealing" protects the integrity of a value, so that a party unsealing the value using
    //     the same key (that was used to seal it) can verify that nobody has tampered with the
    //     value since it was sealed.
    // Each instance of this class will be used to seal, or to unseal, but not both.   If an 
    //     instance is used to do both, its behavior is undefined.
    // If an instance is used to seal a sequence of values, then those values should be unsealed
    //     by a single (other) instance, in the same order that they were sealed.   If such 
    //     values are unsealed in a different order, or by more than one instance, the behavior
    //     is undefined.
    // (N.B.: When we say the "behavior is undefined", this means that there are no guarantees
    //     about what the implementation will do -- any behavior is considered correct.

    public static final int KeySizeBytes = -1;   // IMPLEMENT THIS
    public static final int KeySizeBits = KeySizeBytes*8;

    public DataSealer(byte[] key) {
	assert key.length == KeySizeBytes;

	// IMPLEMENT THIS
    }

    public byte[] seal(byte[] in) {
	// Seals the contents of <in> so that its confidentiality and 
	//    integrity are protected against would-be attackers who do 
	//    not know the key that was used to initialize this DataSealer.
	// This returns a newly allocated byte[] containing the sealed value.

	return null;   // IMPLEMENT THIS
    }

    public byte[] unseal(byte[] in) {
	// Unseals the contents of <in>.  The value passed in will normally
	//    have been created by calling seal() in a DataSealer that was
	//    initialized with the same key as this DataSealer.
	//  If the integrity of the sealed value cannot be verified, this 
        //    returns null.   Otherwise it returns a newly allocated 
        //    byte-array containing the value that was originally 
	//    passed to seal().

	return null;   // IMPLEMENT THIS
    }
}